/*
 *      fltpr.c - Floating Print Helpers
 */

# define max(a,b)  (a < b)?a:b

int     _fltu2(){}	/* define symbol to force load */
char *fcvt(), *ecvt();


/*
 *      pgen - process 'g' format
 *
 *      pargs - pointer to args pointer. Will be updated
 *      pwp   - pointer to output buffer pointer.  Will be updated
 *      ndfnd  - ==0 if ndigit is invalid
 *      ndigit - number of digits to decode, iff ndfnd != 0
 */

pgen (pargs, pwp, ndigit, ndfnd)
	double  **pargs;
	char    **pwp;
	int     ndigit, ndfnd;

{
	if (ndfnd == 0)
		ndigit = 6;
	gcvt (*(*pargs)++, ndigit, *pwp);
	while (*(*pwp)++)  ;            /* scan to end */
	(*pwp)--;                       /* point to 00 char */
}




/*
 *      pfloat - Process Floating Format
 *
 *      pargs - pointer to args pointer. Will be updated
 *      pwp   - pointer to output buffer pointer.  Will be updated
 *      ndfnd  - ==0 if ndigit is invalid
 *      ndigit - number of digits to decode, iff ndfnd != 0
 */

pfloat (pargs, pwp, ndigit, ndfnd)
	double  **pargs;
	char    **pwp;
	int     ndigit, ndfnd;

{
	register char   *sp;
	register int    i;
	register char   *tp;
	static int decpt, sign;

	tp = *pwp;
	if (ndfnd == 0)
		ndigit = 6;
	sp = fcvt (*(*pargs)++, ndigit, &decpt, &sign);
	if (sign)
		*tp++ = '-';                /* if negative */
	if (decpt <= 0)
		*tp++ = '0';                /* if starts with dp */
	else
		for (i=0; i++ < decpt; )        /* copy significant digits */
			*tp++ = *sp++;
	if (ndigit)
		*tp++ = '.';
	if ((decpt = -decpt) >= 0) {
		i = max(decpt, ndigit);
		ndigit -= i;
		for (; i--; )
			*tp++ = '0';
	}
	for (i=0; i++<ndigit; )
		*tp++ = *sp++;
	*pwp = tp;                      /* store updated targ pointer */
}




/*
 *      pscien - Process Scientific Format
 *
 *      pargs - pointer to args pointer. Will be updated
 *      pwp   - pointer to output buffer pointer.  Will be updated
 *      ndfnd  - ==0 if ndigit is invalid
 *      ndigit - number of digits to decode, iff ndfnd != 0
 */

pscien (pargs, pwp, ndigit, ndfnd)
	double  **pargs;
	char    **pwp;
	int     ndigit, ndfnd;

{
	register char   *sp;
	register int    i;
	register char   *tp;
	static int decpt, sign;

	tp = *pwp;
	if (ndfnd == 0)
		ndigit = 6;
	sp = ecvt (*(*pargs)++, ndigit, &decpt, &sign);
	if (sign)
		*tp++ = '-';                /* if negative */
	if (*sp == '0')
		decpt++;
	*tp++ = *sp++;
	*tp++ = '.';
	while (--ndigit > 0)
		*tp++ = *sp++;
	*tp++ = 'e';
	decpt--;
	if (decpt >= 0)
		*tp++ = '+';
	else {
		*tp++ = '-';
		decpt = -decpt;
	}
	*tp++ = (char)(decpt/10 + '0');
	*tp++ = (char)(decpt%10 + '0');
	*pwp = tp;                      /* store updated targ pointer */
}
