|       C library -- setjmp, longjmp
|
|               longjmp (a, v);
|       will generate a return (v) from
|       the last call to
|               setjmp (a);
|
|       by restoring sp, bp, pc, and other regs from buffer 'a'
|       and doing a return;
|       format of the buffer
|       0,1 bp
|       2,3 di
|       4,5 si
|       6,7 sp                  points to spot for retaddr
|       8,9 ret addr            retadr value to use
|
|
	.globl  _setjmp
	.globl  _longjmp

	.text

_setjmp:                        | setjmp (a)   a is offset 4

|       store the frame info for the guy called by our caller
|       (at the moment, us)

	xchg    ax,bp           | (ax) = saved bp
	mov     bp,sp
	mov     bx,*2.(bp)      | arg 1 == address of buffer
	mov     (bx),ax         | store off old bp
	mov     *2(bx),di       | and put the other regs into the buffer
	mov     *4(bx),si
	mov     *6(bx),sp
	mov     cx,*0(bp)       | cx = return address
	mov     *8.(bx),cx
	xchg    ax,bp           | restore bp
	sub     ax,ax           | return 0
	ret


	.globl  _longjmp
	.text

_longjmp:                       | longjmp (a,v) a is at 4, v is at 6
	mov     bp,sp           | old bp will be roached anyways..
	mov     bx,*2(bp)       | so we get args from 2 less than normal
	mov     cx,(bx)         | cx = new bp so we can use bp as arg ptr
	mov     di,*2(bx)
	mov     si,*4(bx)
	mov     ax,*4(bp)       | do the return value now as we are
				| about to stomp the stack pointer

	mov     sp,*6(bx)       | set the stack pointer to the old place
	mov     bp,sp
	mov     bx,*8.(bx)      | put the bogus return address
	mov     *0(bp),bx       | at the stack pointer.
	mov     bp,cx           | patch up bp
	ret                     | and return through stack pointer
