    1    0000                     	|***    old = sbrk(increment);
    2    0000                     	|	
    3    0000                     	|	sbrk gets increment more core, and returns a pointer
    4    0000                     	|	       to the beginning of the new core area
    5    0000                     	|	
    6    0000                     	|       Note that sbrk only receives a 16 bit value, but since its
    7    0000                     	|       expected to be able to shrink or grow up to 65K, it really
    8    0000                     	|       needs a 17 bit argument.
    9    0000                     	|
   10    0000                     	|       This comes about due to the sloppy implimentation and use of
   11    0000                     	|       sbrk.  Heres what we'll do:
   12    0000                     	|
   13    0000                     	|       if (current+delta) does not overflow, assume we're growing
   14    0000                     	|               and do it
   15    0000                     	|       else if (delta < 0) we're shrinking, do it
   16    0000                     	|       else error
   17    0000                     	|
   18    0000                     	|       This means:
   19    0000                     	|               1) we can't "shrink" more than 32K per call
   20    0000                     	|               2) if the caller wants to grow more than 32K and
   21    0000                     	|                  there isnt that much available, we'll shrink instead
   22    0000                     	|                  without any diagnostic.
   23    0000                     	
   24    0000                     	
   25    0000                     		.globl  _sbrk, _brk
   26    0000                     		.globl	nd, _end
   27    0000                     		.comm	_errno,2
   28    0000                     		.break = 17.
   29    0000                     		ENOMEM = 12.
   30    0000                     	
   31    0000                     		.text
   32    0000                     	_sbrk:
   33    0000   8b dc             		mov     bx,sp
   34    0002   8b 5f 02          		mov     bx,*2(bx)               | (bx) = increment
   35    0005   8b cb             		mov     cx,bx                   | (cx) = copy of increment
   36    0007   a1 00 00          		mov     ax,nd                   | (ax) = current break
   37    000a   23 db             		and     bx,bx
   38    000c   74 00             		jz      sbrk2                   | no change, just report
   39    000e   03 d8             		add     bx,ax
   40    0010   73 00             		jnc     sbrk1                   | its ok, he's growing
   41    0012   23 c9             		and     cx,cx
   42    0014   79 00             		jns	sbrk6			| not shrinking, he overflew
   43    0016   b8 11 00          	sbrk1:  mov     ax,*.break
   44    0019   ff 1e 00 00       		calli   @Iscadr                 | call XENIX
   45    001d   72 00             		jb      sbrk8                   | error
   46    001f                     	
   47    001f   a1 00 00          		mov     ax,nd                   | return old limit
   48    0022   8b dc             		mov     bx,sp
   49    0024   8b 5f 02          		mov     bx,*2(bx)
   50    0027   03 d8             		add     bx,ax                   | increment limit
   51    0029   89 1e 00 00       		mov     nd,bx
   52    002d   c3                	sbrk2:  ret
   53    002e                     	
   54    002e   b8 0c 00          	sbrk6:  mov     ax,#ENOMEM
   55    0031   a3 00 00          	sbrk8:  mov     _errno,ax
   56    0034   b8 ff ff          		mov     ax,#-1
   57    0037   c3                		ret
   58    0038                     	
   59    0038                     	
   60    0038                     	
   61    0038                     	|***    brk(value)
   62    0038                     	|
   63    0038                     	|	Set program break
   64    0038                     	|	returns 0 for ok, -1 for error.
   65    0038                     	
   66    0038                     	_brk:
   67    0038   8b dc             		mov     bx,sp
   68    003a   8b 5f 02          		mov     bx,*2(bx)       | arg 1
   69    003d   53                		push    bx              | save request
   70    003e   b8 11 00          		mov     ax,*.break
   71    0041   ff 1e 00 00       		calli   @Iscadr         | call XENIX
   72    0045   58                		pop     ax              | (ax) = requested amount
   73    0046   73 00             		jnb     lab1            | no error
   74    0048   a3 00 00          		mov     _errno,ax
   75    004b   b8 ff ff          		mov     ax,#-1
   76    004e   c3                		ret
   77    004f                     	lab1:
   78    004f   a3 00 00          		mov     nd,ax
   79    0052   2b c0             		sub     ax,ax           | return 0
   80    0054   c3                		ret
   81    0055                     	
   82    0000                     		.data
   83    0000                     	nd:
   84    0000   00 00             		.word   _end
   85    0002                     	
   86    0055                     		.end
